<template>
  <div>
<!-- select 2 demo -->
    <b-modal
      id="modal-startActivitie"
      title="Iniciar Actividad"
      hide-footer
    >
      <b-form>
        <b-form-group
          label="Duración estimada (horas)"
          label-for="estimated_time"
          
        >
          <b-form-input
            id="estimated_time"
            type="number"
            :state="validationTime"
            onKeyUp=" if (this.value.length > 4) {this.value = this.value.slice(0, 4)} if(this.value<0){this.value= this.value * -1}"
            v-model="formData.estimated_time"
            placeholder="Duración estimada"
          />
            <b-form-invalid-feedback :state="validationTime">
                  La duración debe ser un número mayor a cero
            </b-form-invalid-feedback>
        </b-form-group>
        <b-form-group
          label="Fecha de inicio"
          label-for="start_date"
        >
            <b-form-datepicker id="start_date" v-model="formData.start_date" class="mb-2"></b-form-datepicker>
            <b-form-invalid-feedback :state="validationStartDate">
              Es obligatorio escoger una fecha de inicio
            </b-form-invalid-feedback>
        </b-form-group>
       
        <b-form-group
          label="Fecha de terminación"
          label-for="end_date"
        >
            <b-form-datepicker id="end_date" v-model="formData.end_date" class="mb-2"></b-form-datepicker>
            <b-form-invalid-feedback :state="validationEndDate">
              Es obligatorio escoger una fecha de terminación
            </b-form-invalid-feedback>
            <b-form-invalid-feedback :state="validationRange">
                  La fecha de terminación debe ser mayor a la de inicio
            </b-form-invalid-feedback>
        </b-form-group>
        

        <b-button  variant="primary" @click="submit"  class="ml-1" :disabled="lockedSubmit.time || lockedSubmit.start_date || lockedSubmit.end_date || lockedSubmit.range">
            Iniciar
        </b-button>
         <b-button  variant="outline-secondary" @click="cancel"  class="ml-1">
            Cancelar
        </b-button>
      </b-form>
    </b-modal>
  </div>
    
</template>

<script>
import BCardCode from '@core/components/b-card-code'
import {
  BButton, BModal, VBModal, BForm, BFormInput, BFormGroup, BCardText,BFormDatepicker,BFormInvalidFeedback,
} from 'bootstrap-vue'
import Ripple from 'vue-ripple-directive'

export default {
    props:{
        idActivitie:{
            type:Number,
         
        },
         idProject:{
            type:Number,
        
        }
    },
  components: {
    BCardCode,
    BButton,
    BModal,
    BForm,
    BFormInput,
    BCardText,
    BFormGroup,
    BFormDatepicker,
    BFormInvalidFeedback,
  },
  directives: {
    'b-modal': VBModal,
    Ripple,
  },
  data() {
    return {
        formData:{
            id:'',
            estimated_time:0,
            start_date:null,
            end_date:null
        },
        defaultFormData:{
            estimated_time:0,
            start_date:'',
            end_date:''
        },
        lockedSubmit:{
          time:true,
          start_date:true,
          end_date:true,
          range:false,
        }

    }
  },
  methods:{
      submit(){
        let alert
    
          alert = this.$swal({
            
            title: '¿Está seguro de iniciar la actividad ?',
            text: "!La actividad será marcada como iniciada!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'Si, guardar!',
            customClass: {
              confirmButton: 'btn btn-primary',
              cancelButton: 'btn btn-outline-danger ml-1',
            },
            buttonsStyling: false,

          })
             
          alert.then(result => {
            if (result.value) {
              
                this.formData.id=this.idActivitie
                this.formData.estimated_time=parseFloat(this.formData.estimated_time)

                this.$http.post("project/activities/start", this.formData).then((res) => {
                      this.$swal({
                          icon: 'success',
                          title: 'Listo!',
                          text: 'La actividad ha sido iniciada correctamente.',
                          customClass: {
                            confirmButton: 'btn btn-success',
                          },
                      })
                    
                      if (res.data.message === "agregado") {
                        this.$bvModal.hide('modal-startActivitie')
                        this.formData = { ...this.defaultFormData };
                        this.$emit('success', true)
                      }
                }).catch((err) => {
                    console.log(err);
                });

              } else {
              this.$swal({
                title: 'Cancelado',
                text: 'La actividad sigue sin iniciar',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            }
          })

      
      },
      cancel(){
        this.formData = { ...this.defaultFormData };
        this.$bvModal.hide('modal-startActivitie')
      }
  },
  computed: {
      validationTime() {
        if(this.formData.estimated_time > 0 ){
          this.lockedSubmit.time = false
          return true 
        }else{
          this.lockedSubmit.time = true
          return false 
        }
       
      },
      validationStartDate(){
        if(this.formData.start_date != null ){
          this.lockedSubmit.start_date = false
          return true 
        }else{
          this.lockedSubmit.start_date = true
          return false 
        }
      },
      validationEndDate(){
        if(this.formData.end_date != null ){
          this.lockedSubmit.end_date = false
          return true 
        }else{
          this.lockedSubmit.end_date = true
          return false 
        }
      },
      validationRange(){
        if(this.formData.end_date >=  this.formData.start_date){
          this.lockedSubmit.range = false
          return true 
        }else{
          this.lockedSubmit.range  = true
          return false 
        }
      }
    
      
     
    },
}
</script>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
